﻿'
' Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
'
Imports System.Drawing
Imports System.IO
Imports System.Web.Script.Serialization
Imports System.Xml

Imports MindFusion.Scheduling
Imports MindFusion.Scheduling.WebForms

    Partial Class _Default
        Inherits System.Web.UI.Page

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

            AddHandler _calendar.ItemCreated, AddressOf _calendar_ItemCreated
            AddHandler _calendar.ResourceSerialization, AddressOf _calendar_ResourceSerialization

            If Not IsPostBack Then
                If Schedule.IsClassRegistered("custom:res") Then
                    Schedule.UnregisterClass("custom:res")
                End If
                Schedule.RegisterResourceClass(GetType(MyResource), "custom:res", 1)

                _calendar.ItemTooltipFormat = "%s[d] %h"
            End If

            If IsPostBack Then
                If Not String.IsNullOrEmpty(hidden.Value) Then
                    If hidden.Value = "1" Then
                        _calendar.CurrentView = CalendarView.Timetable
                    ElseIf hidden.Value = "2" Then
                        _calendar.CurrentView = CalendarView.SingleMonth
                    ElseIf hidden.Value = "p" Then
                        If _calendar.CurrentView = CalendarView.Timetable Then
                            currentDate = currentDate.AddDays(-5)
                        ElseIf _calendar.CurrentView = CalendarView.SingleMonth Then
                            currentDate = currentDate.AddMonths(-1)
                        End If
                    ElseIf hidden.Value = "n" Then
                        If _calendar.CurrentView = CalendarView.Timetable Then
                            currentDate = currentDate.AddDays(+5)
                        ElseIf _calendar.CurrentView = CalendarView.SingleMonth Then
                            currentDate = currentDate.AddMonths(+1)
                        End If
                    End If

                    hidden.Value = ""
                End If

                If Not String.IsNullOrEmpty(hfilter.Value) Then
                    Dim resId As String = hfilter.Value.Substring(1)
                    Dim resource As Resource = _calendar.Schedule.Resources(resId)
                    If hfilter.Value(0) = "+"c Then
                        _calendar.Resources.Add(resource)
                    Else
                        _calendar.Resources.Remove(resource)
                    End If

                    hfilter.Value = ""
                End If

                If Not String.IsNullOrEmpty(haddres.Value) Then
                    Dim resource As New MyResource()
                    resource.Name = haddres.Value
                    resource.MainColor = Colors((_calendar.Schedule.Resources.Count + 1) Mod Colors.Length)(0)
                    resource.BorderColor = Colors((_calendar.Schedule.Resources.Count + 1) Mod Colors.Length)(1)
                    _calendar.Resources.Add(resource)

                    haddres.Value = ""
                End If
            Else
                ' !IsPostBack
                _calendar.GroupType = GroupType.FilterByResources
                _calendar.Resources.Add(New MyResource() With { _
                 .Name = "Calendar #1", _
                 .MainColor = "#EE9939", _
                 .BorderColor = "#BA782D" _
                })
                _calendar.Resources.Add(New MyResource() With { _
                 .Name = "Calendar #2", _
                 .MainColor = "#C7561E", _
                 .BorderColor = "#944016" _
                })
                _calendar.Resources.Add(New MyResource() With { _
                 .Name = "Calendar #3", _
                 .MainColor = "#41A527", _
                 .BorderColor = "#2D731C" _
                })
            End If

            If _calendar.CurrentView = CalendarView.Timetable Then
                _calendar.TimetableSettings.Dates.Clear()
                For i As Integer = 0 To 4
                    _calendar.TimetableSettings.Dates.Add(New TimetableDate(currentDate.AddDays(i)))
                Next
            ElseIf _calendar.CurrentView = CalendarView.SingleMonth Then
                _calendar.[Date] = currentDate
            End If

            ' Update header
            If _calendar.CurrentView = CalendarView.Timetable Then
                Dim start As DateTime = _calendar.TimetableSettings.Dates(0).Value
                Dim [end] As DateTime = _calendar.TimetableSettings.Dates(_calendar.TimetableSettings.Dates.Count - 1).Value
                If start.Year <> [end].Year Then
                    hheader.Value = String.Format("{0:MMM d, yyyy} - {1:MMM d, yyyy}", start, [end])
                ElseIf start.Month <> [end].Month Then
                    hheader.Value = String.Format("{0:MMM d} - {1:MMM d, yyyy}", start, [end])
                Else
                    hheader.Value = String.Format("{0:MMM d} - {1:d, yyyy}", start, [end])
                End If
            ElseIf _calendar.CurrentView = CalendarView.SingleMonth Then
                hheader.Value = currentDate.ToString("MMMM yyyy")
            End If
        _calendar.TimetableSettings.HeaderCellStyle.Brush.Color = Color.White
        _calendar.TimetableSettings.ShowWorkTime = State.Disabled
        _calendar.TimetableSettings.CellSize = 20
        _calendar.TimetableSettings.Style.Borders.TopStyle = BorderStyle.None
        _calendar.TimetableSettings.Style.Borders.LeftStyle = BorderStyle.None
        _calendar.TimetableSettings.Style.Borders.BottomColor = Color.FromArgb(&HDDDDDD)
        _calendar.TimetableSettings.Style.Borders.RightColor = Color.FromArgb(&HDDDDDD)

        _calendar.TimetableSettings.ShowNavigationButtons = State.Disabled

        _calendar.TimetableSettings.TimelineStyle.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.TimetableSettings.TimelineStyle.Borders.AllStyle = BorderStyle.Solid
        _calendar.TimetableSettings.TimelineStyle.Borders.AllWidth = 1
        _calendar.TimetableSettings.TimelineStyle.Borders.RightWidth = 0
        _calendar.TimetableSettings.TimelineStyle.Brush.Image = "none"
        _calendar.TimetableSettings.TimelineStyle.Brush.Color = Color.White
        _calendar.TimetableSettings.TimelineStyle.Font.Name = "Verdana"
        _calendar.TimetableSettings.TimelineStyle.Font.Bold = False
        _calendar.TimetableSettings.TimelineStyle.Font.Size = New FontUnit(9, UnitType.Point)
        _calendar.TimetableSettings.TimelineStyle.TextAlignment = TextAlignment.TopLeft
        _calendar.TimetableSettings.TimelineStyle.TextColor = Color.FromArgb(&H666666)

        _calendar.TimetableSettings.Style.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.TimetableSettings.Style.Borders.AllStyle = BorderStyle.Solid
        _calendar.TimetableSettings.Style.Borders.AllWidth = 1
        _calendar.TimetableSettings.Style.Borders.RightWidth = 0
        _calendar.TimetableSettings.Style.Brush.Image = "none"
        _calendar.TimetableSettings.Style.Brush.Color = Color.White

        _calendar.TimetableSettings.MainHeaderStyle.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.TimetableSettings.MainHeaderStyle.Borders.AllStyle = BorderStyle.Solid
        _calendar.TimetableSettings.MainHeaderStyle.Borders.AllWidth = 1
        _calendar.TimetableSettings.MainHeaderStyle.Borders.RightWidth = 0
        _calendar.TimetableSettings.MainHeaderStyle.Brush.Image = "none"
        _calendar.TimetableSettings.MainHeaderStyle.Brush.Color = Color.White
        _calendar.TimetableSettings.MainHeaderStyle.Font.Name = "Verdana"
        _calendar.TimetableSettings.MainHeaderStyle.Font.Bold = False
        _calendar.TimetableSettings.MainHeaderStyle.Font.Size = New FontUnit(9, UnitType.Point)
        _calendar.TimetableSettings.MainHeaderStyle.TextColor = Color.FromArgb(&H666666)

        _calendar.TimetableSettings.CellStyle.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.TimetableSettings.CellStyle.Borders.AllStyle = BorderStyle.Solid
        _calendar.TimetableSettings.CellStyle.Borders.BottomStyle = BorderStyle.Dotted
        _calendar.TimetableSettings.CellStyle.Borders.TopStyle = BorderStyle.Dotted
        _calendar.TimetableSettings.CellStyle.Borders.BottomWidth = 0
        _calendar.TimetableSettings.CellStyle.Borders.RightWidth = 0
        _calendar.TimetableSettings.CellStyle.Brush = New CssBackground() With {.Color = Color.White}

        _calendar.TimetableSettings.TimelineTicksColor = Color.FromArgb(&HDDDDDD)

        _calendar.MonthSettings.DayNamesHeaderHeight = 24

        _calendar.MonthSettings.DaySettings.Style.Brush.Image = "none"
        _calendar.MonthSettings.DaySettings.Style.Brush.Color = Color.White
        _calendar.MonthSettings.DaySettings.Style.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.MonthSettings.DaySettings.Style.Borders.AllWidth = 0
        _calendar.MonthSettings.DaySettings.Style.Borders.BottomWidth = 1
        _calendar.MonthSettings.DaySettings.Style.Borders.RightWidth = 1
        _calendar.MonthSettings.DaySettings.Style.Borders.AllStyle = BorderStyle.Solid

        _calendar.MonthSettings.DaySettings.HeaderStyle.Brush.Image = "none"
        _calendar.MonthSettings.DaySettings.HeaderStyle.Brush.Color = Color.White
        _calendar.MonthSettings.DaySettings.HeaderStyle.Borders.AllWidth = 0
        _calendar.MonthSettings.DaySettings.HeaderStyle.Borders.AllStyle = BorderStyle.None
        _calendar.MonthSettings.DaySettings.HeaderStyle.TextAlignment = TextAlignment.MiddleLeft
        _calendar.MonthSettings.DaySettings.HeaderStyle.TextMargins.Left = 2
        _calendar.MonthSettings.DaySettings.HeaderStyle.TextColor = Color.Black
        _calendar.MonthSettings.DaySettings.HeaderStyle.Font.Name = "Verdana"
        _calendar.MonthSettings.DaySettings.HeaderStyle.Font.Bold = False
        _calendar.MonthSettings.DaySettings.HeaderStyle.Font.Size = New FontUnit(9, UnitType.Point)

        _calendar.MonthSettings.Style.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.MonthSettings.Style.Borders.AllStyle = BorderStyle.Solid
        _calendar.MonthSettings.Style.Borders.AllWidth = 0
        _calendar.MonthSettings.Style.Borders.LeftWidth = 1
        _calendar.MonthSettings.Style.Borders.TopWidth = 1

        _calendar.MonthSettings.Style.Brush.Color = Color.White
        _calendar.MonthSettings.Style.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.MonthSettings.Style.Borders.AllStyle = BorderStyle.Solid
        _calendar.MonthSettings.Style.Borders.AllWidth = 0
        _calendar.MonthSettings.Style.Borders.BottomWidth = 1

        _calendar.MonthSettings.DayNamesHeaderStyle.Brush.Color = Color.White
        _calendar.MonthSettings.DayNamesHeaderStyle.Brush.Image = "none"
        _calendar.MonthSettings.DayNamesHeaderStyle.Borders.AllColor = Color.FromArgb(&HDDDDDD)
        _calendar.MonthSettings.DayNamesHeaderStyle.Borders.AllStyle = BorderStyle.Solid
        _calendar.MonthSettings.DayNamesHeaderStyle.Borders.AllWidth = 0
        _calendar.MonthSettings.DayNamesHeaderStyle.Borders.BottomWidth = 1
        _calendar.MonthSettings.DayNamesHeaderStyle.TextAlignment = TextAlignment.MiddleLeft
        _calendar.MonthSettings.DayNamesHeaderStyle.TextColor = Color.FromArgb(&H666666)
        _calendar.MonthSettings.DayNamesHeaderStyle.TextMargins.Left = 2
        _calendar.MonthSettings.DayNamesHeaderStyle.Font.Name = "Verdana"
        _calendar.MonthSettings.DayNamesHeaderStyle.Font.Bold = False
        _calendar.MonthSettings.DayNamesHeaderStyle.Font.Size = New FontUnit(9, UnitType.Point)

        End Sub

        Private Sub _calendar_ItemCreated(ByVal sender As Object, ByVal e As ItemEventArgs)
        End Sub

        Private Sub _calendar_ResourceSerialization(ByVal sender As Object, ByVal e As SerializationEventArgs)
            e.AddDefaultConverter = True
            e.Serializer.RegisterConverters(New JavaScriptConverter() {New MyResourceConverter(_calendar)})
        End Sub


        Private Shared Colors As String()() = New String()() { _
         New String() {"rgb(217, 102, 102)", "rgb(204, 51, 51)"}, _
         New String() {"rgb(230, 115, 153)", "rgb(221, 68, 119)"}, _
         New String() {"rgb(179, 115, 179)", "rgb(153, 68, 153)"}, _
         New String() {"rgb(140, 102, 217)", "rgb(102, 51, 204)"}, _
         New String() {"rgb(102, 140, 179)", "rgb(51, 102, 153)"}, _
         New String() {"rgb(102, 140, 217)", "rgb(51, 102, 204)"}, _
         New String() {"rgb(89, 191, 179)", "rgb(34, 170, 153)"}, _
         New String() {"#65AD89", "#329262"}, _
         New String() {"#4CB052", "#109618"}, _
         New String() {"#8CBF40", "#66AA00"}, _
         New String() {"#BFBF4D", "#AAAA11"}, _
         New String() {"#E0C240", "#D6AE00"}, _
         New String() {"rgb(242, 166, 64)", "rgb(238, 136, 0)"}, _
         New String() {"#E6804D", "#DD5511"}, _
         New String() {"#BE9494", "#A87070"}, _
         New String() {"#A992A9", "#8C6D8C"}, _
         New String() {"#8997A5", "#627487"}, _
         New String() {"#94A2BE", "#7083A8"}, _
         New String() {"#85AAA5", "#5C8D87"}, _
         New String() {"rgb(167, 167, 125)", "rgb(137, 137, 81)"}, _
         New String() {"#C4A883", "#B08B59"}, _
         New String() {"#C7561E", "#9F3501"}, _
         New String() {"#B5515D", "#8A2D38"}, _
         New String() {"#C244AB", "#962181"}, _
         New String() {"#603F99", "#402175"}, _
         New String() {"rgb(83, 108, 166)", "rgb(48, 72, 126)"}, _
         New String() {"#3640AD", "#182186"}, _
         New String() {"#3C995B", "#1F753C"}, _
         New String() {"#5CA632", "#3D8215"}, _
         New String() {"#7EC225", "#5A9A08"}, _
         New String() {"#A7B828", "#81910B"}, _
         New String() {"rgb(207, 153, 17)", "rgb(157, 112, 0)"}, _
         New String() {"#D47F1E", "#AA5A00"}, _
         New String() {"#B56414", "#8D4500"}, _
         New String() {"#914D14", "#743500"}, _
         New String() {"#AB2671", "#870B50"}, _
         New String() {"rgb(150, 67, 165)", "rgb(112, 35, 127)"}, _
         New String() {"rgb(69, 133, 163)", "rgb(37, 97, 125)"}, _
         New String() {"rgb(115, 115, 115)", "rgb(81, 81, 81)"}, _
         New String() {"#41A587", "#227F63"}, _
         New String() {"#D1BC36", "#A59114"}, _
         New String() {"#AD2D2D", "#871111"} _
        }

        Private Shared currentDate As DateTime = DateTime.Today

    End Class


    Public Class MyResource
        Inherits Resource

        Public Sub New()
        End Sub

        Public Overrides Sub SaveTo(ByVal writer As BinaryWriter, ByVal context As BinarySerializationContext)
            MyBase.SaveTo(writer, context)

            writer.Write(m_mainColor)
            writer.Write(m_borderColor)
        End Sub

        Public Overrides Sub SaveTo(ByVal element As XmlElement, ByVal context As XmlSerializationContext)
            MyBase.SaveTo(element, context)

            context.WriteString(m_mainColor, "mainColor", element)
            context.WriteString(m_borderColor, "borderColor", element)
        End Sub

        Public Overrides Function SaveViewState() As Object
            If Not String.IsNullOrEmpty(m_mainColor) Then
                ViewState("mainColor") = m_mainColor
            End If
            If Not String.IsNullOrEmpty(m_borderColor) Then
                ViewState("borderColor") = m_borderColor
            End If

            Return MyBase.SaveViewState()
        End Function

        Public Overrides Sub LoadFrom(ByVal reader As System.IO.BinaryReader, ByVal context As BinarySerializationContext)
            MyBase.LoadFrom(reader, context)

            m_mainColor = reader.ReadString()
            m_borderColor = reader.ReadString()
        End Sub

        Public Overrides Sub LoadFrom(ByVal element As System.Xml.XmlElement, ByVal context As XmlSerializationContext)
            MyBase.LoadFrom(element, context)

            m_mainColor = context.ReadString("mainColor", element)
            m_borderColor = context.ReadString("borderColor", element)
        End Sub

        Public Overrides Sub LoadViewState(ByVal state As Object)
            MyBase.LoadViewState(state)

            If ViewState("mainColor") IsNot Nothing Then
                m_mainColor = ViewState("mainColor").ToString()
            End If
            If ViewState("borderColor") IsNot Nothing Then
                m_borderColor = ViewState("borderColor").ToString()
            End If
        End Sub


        Public Property MainColor() As String
            Get
                Return m_mainColor
            End Get
            Set(ByVal value As String)
                m_mainColor = value
            End Set
        End Property

        Public Property BorderColor() As String
            Get
                Return m_borderColor
            End Get
            Set(ByVal value As String)
                m_borderColor = value
            End Set
        End Property


        Private m_mainColor As String
        Private m_borderColor As String

    End Class


    Public Class MyResourceConverter
        Inherits ResourceConverter

        Public Sub New(ByVal calendar As MindFusion.Scheduling.WebForms.Calendar)
            MyBase.New(calendar)
        End Sub

        Public Overrides Function Serialize(ByVal obj As Object, ByVal serializer As JavaScriptSerializer) As IDictionary(Of String, Object)
            Dim resource = TryCast(obj, MyResource)
            Dim dictionary = MyBase.Serialize(obj, serializer)

            dictionary.Add("mainColor", resource.MainColor)
            dictionary.Add("borderColor", resource.BorderColor)

            Return dictionary
        End Function

        Public Overrides ReadOnly Property SupportedTypes() As IEnumerable(Of Type)
            Get
                Return AddSelf(MyBase.SupportedTypes)
            End Get
        End Property


        Private Function AddSelf(ByVal types As IEnumerable(Of Type)) As IEnumerable(Of Type)
            Dim list As New List(Of Type)(types)
            list.Add(GetType(MyResource))
            Return list
        End Function

    End Class