﻿//
// Copyright (c) 2009-2013, MindFusion LLC - Bulgaria.
//


var bodyMargin = 0;

function onWeekClick()
{
	var calendar = $find('_calendar');
	if (!calendar)
		return;
	
	if (calendar.get_currentView() != MindFusion.Scheduling.CalendarView.Timetable)
	{
		$get('hidden').value = '1';
		__doPostBack('__Page');
	}
}

function onMonthClick()
{
	var calendar = $find('_calendar');
	if (!calendar)
		return;

	if (calendar.get_currentView() != MindFusion.Scheduling.CalendarView.SingleMonth)
	{
		$get('hidden').value = '2';
		__doPostBack('__Page');
	}
}

function onPrevClick()
{
	$get('hidden').value = 'p';
	__doPostBack('__Page');
}

function onNextClick()
{
	$get('hidden').value = 'n';
	__doPostBack('__Page');
}

function onAddCalendarClick()
{
	showCalendarForm();
}

function pageLoad(e)
{
	$addHandler(document, 'keydown', onKeyDown);
	$addHandler(window, 'resize', onResize);
	$addHandler(document, 'mousedown', onMouseDown);

	resizeCalendar();
	updateUI();
	createItemStyles();
}

function onKeyDown(e)
{
	var keynum;
	if (window.event)
	{
		keynum = e.keyCode
	}
	else if (e.which)
	{
		keynum = e.which
	}
	else
	{
		keynum = e.keyCode
	}

	if (addItemForm)
	{
		if (keynum == 27)
			closeAddItemForm();

		if (keynum == 13)
			createFormItem();
	}
	else if (editItemForm)
	{
		var whatInput = document.getElementById('whatField2');
		if (whatInput)
		{
			if (document.activeElement == whatInput)
			{
				if (keynum == 27)
					hideWhatInput(true);
			
				if (keynum == 13)
					hideWhatInput();

				return;
			}
		}

		if (keynum == 27)
			closeEditItemForm();

		if (keynum == 13)
			editFormItem();
	}
	else if (addCalendarForm)
	{
		if (keynum == 27)
			closeCalendarForm();

		if (keynum == 13)
			createFormCalendar();
	}
}

function onResize(e)
{
	resizeCalendar();
	closeAddItemForm();
	closeEditItemForm();
	closeCalendarForm();
}

function onMouseDown(e)
{
	if (addItemForm)
	{
		// TODO: If the combobox is open (and stretches out of the form)
		// an attempt to select an item which is positioned out of the form closes the form
		var bounds = Sys.UI.DomElement.getBounds(addItemForm);
		if (!(bounds.x <= e.clientX && e.clientX <= bounds.x + bounds.width &&
			bounds.y <= e.clientY && e.clientY <= bounds.y + bounds.height))
			closeAddItemForm();
	}
	else if (editItemForm)
	{
		var bounds = Sys.UI.DomElement.getBounds(editItemForm);
		if (!(bounds.x <= e.clientX && e.clientX <= bounds.x + bounds.width &&
			bounds.y <= e.clientY && e.clientY <= bounds.y + bounds.height))
			closeEditItemForm();
	}
	else if (addCalendarForm)
	{
		var bounds = Sys.UI.DomElement.getBounds(addCalendarForm);
		if (!(bounds.x <= e.clientX && e.clientX <= bounds.x + bounds.width &&
			bounds.y <= e.clientY && e.clientY <= bounds.y + bounds.height))
			closeCalendarForm();
	}
}

function resizeCalendar()
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	var calElement = cal.get_element();
	var bounds = Sys.UI.DomElement.getBounds(calElement);
	var height = Math.max((document.documentElement.clientHeight - (2 * bodyMargin) - 6 - bounds.y), 0) + 'px';
	calElement.style.height = height;

	cal.adjust();
}

function updateUI()
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable)
	{
		document.getElementById('weekButton').style.background = '#E0E0E0';
	}
	else
	{
		document.getElementById('monthButton').style.background = '#E0E0E0';
	}

	document.getElementById('header').innerHTML = $get('hheader').value;

	updateCalendarUI();
}

function createItemStyles()
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	var style = document.createElement('style');
	style.type = 'text/css';

	var styleContent = "";
	for (var i = 0; i < cal.getResources().length; i++)
	{
		var res = cal.getResources()[i];

		var backgroundColor = res.mainColor;
		if (!backgroundColor)
			backgroundColor = 'white';

		var borderColor = res.borderColor;
		if (!borderColor)
			borderColor = 'gray';

		// Daily views, subject
		styleContent += '.res' + res.getId() + ' .subject\n';
		styleContent += '{\n';
		styleContent += '  text-align: left !important;\n';
		styleContent += '  font-family: Verdana !important;\n';
		styleContent += '  font-size: 9pt !important;\n';
		styleContent += '  font-weight: normal !important;\n';
		styleContent += '  color: #1D1D1D !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		// Timeline view, header
		styleContent += '.res' + res.getId() + ' .wrapper .borders .inwrap .frame .text-table .header\n';
		styleContent += '{\n';
		styleContent += '  text-align: left !important;\n';
		styleContent += '  font-family: Verdana !important;\n';
		styleContent += '  font-size: 9pt !important;\n';
		styleContent += '  font-weight: normal !important;\n';
		styleContent += '  color: #1D1D1D !important;\n';
		styleContent += '  border-bottom-color: transparent !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		styleContent += '.res' + res.getId() + ' .wrapper .borders .inwrap .frame .text-table .details\n';
		styleContent += '{\n';
		styleContent += '  text-align: left !important;\n';
		styleContent += '  font-family: Verdana !important;\n';
		styleContent += '  font-size: 7pt !important;\n';
		styleContent += '  font-weight: bold !important;\n';
		styleContent += '  color: #1D1D1D !important;\n';
		styleContent += '  border-bottom-color: transparent !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		// Timetable, background
		styleContent += '.res' + res.getId() + ' .wrapper\n';
		styleContent += '{\n';
		styleContent += '  filter: none !important;\n';
		styleContent += '  background-image: none !important;\n';
		styleContent += '  background-color: ' + backgroundColor + ' !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		// Daily views, background
		styleContent += '.res' + res.getId() + ' .frame\n';
		styleContent += '{\n';
		styleContent += '  background-image: none !important;\n';
		styleContent += '  background-color: ' + backgroundColor + ' !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		// Border
		styleContent += '.res' + res.getId() + ' .wrapper .borders\n';
		styleContent += '{\n';
		styleContent += '  border: solid 1px ' + borderColor + ' !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		// Timetable, move band
		styleContent += '.res' + res.getId() + ' .wrapper .post\n';
		styleContent += '{\n';
		styleContent += '  display: none !important;\n';
		styleContent += '}\n';
		styleContent += '\n';

		styleContent += '.res' + res.getId() + ' .wrapper .borders\n';
		styleContent += '{\n';
		styleContent += '  left: 0 !important;\n';
		styleContent += '}\n';
		styleContent += '\n';
	}
	if (Sys.Browser.name == "Microsoft Internet Explorer" && Sys.Browser.version < 9) {
	    style.styleSheet.cssText = styleContent;
	}
	else {
	    style.innerHTML = styleContent;
	}

	var head = document.getElementsByTagName('head')[0];
	head.appendChild(style);
}

function updateCalendarUI()
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	var table = document.getElementById('calendarsTable');
	$mindfusion('calendarsTable').html('');

	for (var i = 0; i < cal.getResources().length; i++)
	{
		var res = cal.getResources()[i];
		var name = res.getName();
		var color = res.mainColor;
		var id = res.getId();

		var tr = document.createElement('tr');
		var td = document.createElement('td');
		var div = document.createElement('div');
		div.className = 'calendar-list-item';
		div.id = 'r' + id;

		var indiv = document.createElement('div');
		indiv.className = 'calendar-list-square';
		if (isFilteredResource(id))
		{
			indiv.style.background = color;
			indiv.style.borderColor = color;
		}
		else
		{
			indiv.style.background = 'transparent';
			indiv.style.borderColor = '#CCCCCC'; // color?
		}
		div.appendChild(indiv);

		var span = document.createElement('span');
		span.innerHTML = name;
		div.appendChild(span);

		$addHandler(div, 'click', onResourceClick);

		td.appendChild(div);
		tr.appendChild(td);
		table.appendChild(tr);
	}
}

function onInfoMouseOver(e)
{
	var infoPanel = document.getElementById('infoPanel');
	if (!infoPanel)
		return;

	var infoButton = document.getElementById('infoButton');
	if (!infoButton)
		return;

	var bounds = Sys.UI.DomElement.getBounds(infoButton);
	Sys.UI.DomElement.setLocation(infoPanel, bounds.x + bounds.width, bounds.y + bounds.height + 16);

	infoPanel.style.visibility = '';
}

function onInfoMouseOut(e)
{
	var infoPanel = document.getElementById('infoPanel');
	if (!infoPanel)
		return;

	infoPanel.style.visibility = 'hidden';
}

function onResourceClick(e)
{
	var divTarget = e.target;
	while (divTarget && divTarget.id == '')
	{
		if (divTarget.parentElement)
			divTarget = divTarget.parentElement;
		else // parentNode in FF
			divTarget = divTarget.parentNode;
	}

	var cal = $find('_calendar');
	if (!cal)
		return;

	if (divTarget)
	{
		var resId = divTarget.id.substring(1);
		var res = cal.getResourceById(resId);

		var filter = isFilteredResource(resId);
		var hvalue = '';
		if (filter)
			hvalue = '-';
		else
			hvalue = '+';
		hvalue = hvalue + resId;

		$get('hfilter').value = hvalue;
		__doPostBack('__Page');
	}
}

function isFilteredResource(resId)
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	for (var i = 0; i < cal.getFilteredResources().length; i++)
	{
		if (cal.getFilteredResources()[i].getId() == resId)
			return true;
	}

	return false;
}

function onSelectionStart(s, e)
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	start = e.get_startTime();
	end = e.get_endTime();
}

function onSelectionChanged(s, e)
{
	if (!start && !end)
		return;

	var cal = $find('_calendar');
	if (!cal)
		return;

    if (e.get_newSelection()[0] || e.get_newSelection()[1]) {
        start = e.get_newSelection()[0];
        end = e.get_newSelection()[1];
    }
}

function onSelectionEnd(s, e)
{
	if (upCell)
	{
		showAddItemForm(upCell);
		upCell = null;
	}
}

function onItemModifying(s, e)
{
	var cal = $find('_calendar');
	if (!cal)
		return;

	if (cal.get_currentView() != MindFusion.Scheduling.CalendarView.Timetable)
		return;
		
	var item = e.get_item();
	var oldItem = cal.getItemById(item.id, item.occurrenceIndex);
	if (!oldItem) {
	    var oldItem = cal.getItemById(item.id, item.occurrenceIndex);
	}
	var desc = '';
	var newStart = item.getStartTime();
	var newEnd = item.getEndTime();
	if (newStart.__getHours() != 0 || newStart.__getMinutes() != 0 ||
		newEnd.__getHours() != 0 || newEnd.__getMinutes() != 0)
	{
		var startd = '';
		if (newStart.__getHours() >= 12)
			startd = 'p'
		var endd = '';
		if (newEnd.__getHours() >= 12)
			endd = 'p'
		desc = newStart.toString('hh:mm') + startd + ' - ' + newEnd.toString('hh:mm') + endd;
	}

	if (item.getDetails() != desc) {
	    item.setDetails(desc, true);
	}
}

function onItemClick(s, e)
{
	showEditItemForm(e.get_item());
}

function onDateMouseUp(s, e)
{
	upCell = e.get_cell().bgCell;
}

function onFormShow(s, e)
{
	e.set_cancel(true);
}

function getWhenText(start, end)
{
	// This should never happen, but keep the check for just in case
	if (!start || !end)
		return;

	// Find the calendar control
	var cal = $find('_calendar');
	if (!cal)
		return;

	var displayStart = start.clone();
	var displayEnd = end.clone();
	if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.SingleMonth)
		displayEnd.addDays(-1);
	if (displayStart.__getFullYear() == displayEnd.__getFullYear() &&
		displayStart.__getMonth() == displayEnd.__getMonth() &&
		displayStart.__getDate() == displayEnd.__getDate())
	{
		var exact = displayStart.__getHours() == displayEnd.__getHours() &&
			displayStart.__getMinutes() == displayEnd.__getMinutes() &&
			displayStart.__getSeconds() == displayEnd.__getSeconds();

		if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable && !exact)
			return displayStart.toString('ddd, MMMM d') + ', ' + displayStart.toString('H:mm tt') + ' - ' + displayEnd.toString('H:mm tt');
		else
			return displayStart.toString('ddd, MMMM d');
	}
	else
	{
		return displayStart.toString('ddd, MMMM d') + ' - ' + displayEnd.toString('ddd, MMMM d');
	}
}

function showAddItemForm(cell)
{
	// This should never happen, but keep the check for just in case
	if (!start || !end)
		return;

	// Find the calendar control
	var cal = $find('_calendar');
	if (!cal)
		return;

	if (addItemForm)
		closeAddItemForm();

	// Create the visible form frame, which will host the other html elements
	addItemForm = document.createElement('div');
	var h = 230;
	var w = 350;
	addItemForm.style.width = w + 'px';
	addItemForm.style.height = h + 'px';
	addItemForm.style.zIndex = 8000;

	// Place the form relatively to the target cell. Additionally apply the
	// appropriate style so that the pointer is positioned correctly
	var parentBounds;
	if (cell)
		parentBounds = Sys.UI.DomElement.getBounds(cell);
	else
		parentBounds = { x: 0, y: 0, width: 0, height: 0 };
	addItemForm.className = 'popup-above';
	var location = { x: parentBounds.x, y: parentBounds.y + parentBounds.height + bodyMargin };
	var left = true;
	if (location.x + w > document.documentElement.clientWidth - 30)
	{
		location.x = parentBounds.x + parentBounds.width - w - 20;
		addItemForm.className = 'popup-right-above';
		left = false;

		if (location.x < 0)
			location.x = 0;
	}
	if (location.y + h > document.documentElement.clientHeight - 30)
	{
		location.y = parentBounds.y - h - bodyMargin - 20;
		if (left)
			addItemForm.className = 'popup-below';
		else
			addItemForm.className = 'popup-right-below';

		if (location.y < 0)
			location.y = 0;
	}
	Sys.UI.DomElement.setLocation(addItemForm, Math.round(location.x), Math.round(location.y));
	addItemForm.style.padding = '10px';
	addItemForm.style.fontSize = '9pt';

	// Create the custom form header
	var addItemFormHeader = document.createElement('div');
	addItemForm.appendChild(addItemFormHeader);

	// Create the close button
	var closeButton = document.createElement('a');
	closeButton.className = 'close-button';
	closeButton.alt = 'Close';
	$addHandlers(closeButton, { 'click': closeAddItemForm }, this);
	addItemFormHeader.appendChild(closeButton);
	addItemFormHeader.className = 'popup-header';

	// Add header text
	var headerText = document.createElement('span');
	headerText.innerHTML = 'Create Event';
	addItemFormHeader.appendChild(headerText);

	// Add the hosting form content element
	var addItemFormContent = document.createElement('div');
	addItemFormContent.id = 'main-content';
	addItemForm.appendChild(addItemFormContent);

	// Content div
	var contentDiv = document.createElement('div');
	var contentHeight = h - 55;
	contentDiv.style.height = contentHeight + 'px';
	addItemFormContent.appendChild(contentDiv);

	// Content table
	var content = document.createElement('table');
	content.className = 'popup-content';
	content.cellSpacing = '1px';
	content.cellPadding = '0';
	contentDiv.appendChild(content);

	var col1 = document.createElement('col');
	col1.width = '20%';
	content.appendChild(col1);

	var col2 = document.createElement('col');
	col2.width = '80%';
	content.appendChild(col2);

	// When
	var whenRow = document.createElement('tr');
	var when1 = document.createElement('td');
	when1.innerHTML = 'When:';
	when1.style.color = '#606060';
	whenRow.appendChild(when1);
	var when2 = document.createElement('td');
	when2.innerHTML = getWhenText(start, end);
	whenRow.appendChild(when2);
	content.appendChild(whenRow);

	// Separator
	var sep = document.createElement('td');
	sep.style.height = '5px';
	content.appendChild(sep);

	// What
	var whatRow = document.createElement('tr');
	var what1 = document.createElement('td');
	what1.innerHTML = 'What:';
	what1.className = 'popup-statictext';
	whatRow.appendChild(what1);
	var what2 = document.createElement('td');
	var whatInput = document.createElement('input');
	whatInput.id = 'whatField';
	whatInput.className = 'popup-input';
	what2.appendChild(whatInput);
	whatRow.appendChild(what2);
	content.appendChild(whatRow);

	// Example
	var exampleRow = document.createElement('tr');
	var example1 = document.createElement('td');
	exampleRow.appendChild(example1);
	var example2 = document.createElement('td');
	example2.innerHTML = "e.g., Breakfast at Tiffany's";
	example2.className = 'popup-statictext';
	example2.style.fontSize = '8pt';
	exampleRow.appendChild(example2);
	content.appendChild(exampleRow);

	// Separator
	sep = document.createElement('td');
	sep.style.height = '5px';
	content.appendChild(sep);

	// Calendar
	var calendarRow = document.createElement('tr');
	var calendar1 = document.createElement('td');
	calendar1.innerHTML = 'Calendar:';
	calendar1.className = 'popup-statictext';
	calendarRow.appendChild(calendar1);
	var calendar2 = document.createElement('td');
	var calendarInput = document.createElement('select');
	calendarInput.id = 'calendarField';
	calendarInput.className = 'popup-input';
	for (var i = 0; i < cal.getResources().length; i++)
	{
		var resourceName = cal.getResources()[i].getName();
		var option = document.createElement('option');
		option.innerHTML = resourceName;
		calendarInput.appendChild(option);
	}
	calendar2.appendChild(calendarInput);
	calendarRow.appendChild(calendar2);
	content.appendChild(calendarRow);

	// Create the custom form footer
	var addItemFormFooter = document.createElement('div');
	addItemFormFooter.className = 'buttons-row';
	addItemFormContent.appendChild(addItemFormFooter);

	// Create button
	var btnCreate = document.createElement('a');
	btnCreate.className = 'popup-button';
	btnCreate.style.marginLeft = '5px';
	btnCreate.innerHTML = 'Create';
	$addHandlers(btnCreate, { 'click': createFormItem }, this);
	addItemFormFooter.appendChild(btnCreate);

	document.body.appendChild(addItemForm);

	whatInput.focus();
}

function createFormItem()
{
	var whatInput = document.getElementById('whatField');
	if (!whatInput)
		return;

	var calendarInput = document.getElementById('calendarField');
	if (!calendarInput)
		return;

	var cal = $find('_calendar');
	if (!cal)
		return;

	var res = cal.getResources()[calendarInput.selectedIndex];
	var desc = '';
	if (start.__getHours() != 0 || start.__getMinutes() != 0 ||
		end.__getHours() != 0 || end.__getMinutes() != 0)
	{
		var startd = '';
		if (start.__getHours() >= 12)
			startd = 'p'
		var endd = '';
		if (end.__getHours() >= 12)
			endd = 'p'
		desc = start.toString('hh:mm') + startd + ' - ' + end.toString('hh:mm') + endd;
	}

	var item = cal.createItem(
		{
			startTime: start,
			endTime: end,
			subject: whatInput.value,
			resources: [ res.getId() ],
			cssClass: 'res' + res.getId(),
			details: desc
		});
	closeAddItemForm();

	return item;
}

function closeAddItemForm()
{
	try
	{
		if (addItemForm)
		{
			document.body.removeChild(addItemForm);
			addItemForm = null;
		}
	}
	catch (err) { }

	var cal = $find('_calendar');
	if (!cal.view.isSelecting)
		cal.clearSelection();
}

function isDate(date)
{
	return (date.__getHours() == 0 && date.__getMinutes() == 0 && date.__getSeconds() == 0);
}

function showEditItemForm(item)
{
	if (!item)
		return;

	var cal = $find('_calendar');
	if (!cal)
		return;

	if (editItemForm)
		closeEditItemForm();

	editedItem = item;

	var itemRes;
	if (item.getResources().length > 0)
		itemRes = item.getResources()[0];

	// Create the visible form frame, which will host the other html elements
	editItemForm = document.createElement('div');
	var h = 150;
	var w = 350;
	editItemForm.style.width = w + 'px';
	editItemForm.style.height = h + 'px';
	editItemForm.style.zIndex = 8000;

	// Place the form relatively to the target cell. Additionally apply the
	// appropriate style so that the pointer is positioned correctly
	var cells = cal.getTimeCells(item.getStartTime(), item.getEndTime(), false, null);
	var cell;
	if (isDate(item.getStartTime()) && isDate(item.getEndTime()))
		cell = cells[0].bgCell;
	else
		cell = cells[cells.length - 1].bgCell;
	if (cell)
		parentBounds = Sys.UI.DomElement.getBounds(cell);
	else
		parentBounds = { x: 0, y: 0, width: 0, height: 0 };

	editItemForm.className = 'popup-above';
	var location = { x: parentBounds.x, y: parentBounds.y + parentBounds.height + bodyMargin};
	var left = true;
	if (location.x + w > document.documentElement.clientWidth - 40)
	{
		location.x = parentBounds.x + parentBounds.width - w - 30;
		editItemForm.className = 'popup-right-above';
		left = false;

		if (location.x < 0)
			location.x = 0;
	}
	if (location.y + h > document.documentElement.clientHeight - 30)
	{
		location.y = parentBounds.y - h - bodyMargin - 30;
		if (left)
			editItemForm.className = 'popup-below';
		else
			editItemForm.className = 'popup-right-below';

		if (location.y < 0)
			location.y = 0;
	}
	Sys.UI.DomElement.setLocation(editItemForm, Math.round(location.x), Math.round(location.y));
	editItemForm.style.padding = '10px';
	editItemForm.style.fontSize = '9pt';

	// Create the custom form header
	var editItemFormHeader = document.createElement('div');
	editItemForm.appendChild(editItemFormHeader);

	// Create the close button
	var closeButton = document.createElement('a');
	closeButton.className = 'close-button';
	closeButton.alt = 'Close';
	$addHandlers(closeButton, { 'click': closeEditItemForm }, this);
	editItemFormHeader.appendChild(closeButton);
	editItemFormHeader.className = 'popup-header';

	// Add header icon & text
	var indiv = document.createElement('div');
	indiv.className = 'calendar-list-square';
	indiv.style.top = '1px';
	if (itemRes)
	{
		indiv.style.background = itemRes.mainColor;
		indiv.style.borderColor = itemRes.borderColor;
	}
	else
	{
		indiv.style.background = 'transparent';
		indiv.style.borderColor = '#CCCCCC';
	}
	editItemFormHeader.appendChild(indiv);

	var headerText = document.createElement('span');
	headerText.innerHTML = 'Edit Event';
	editItemFormHeader.appendChild(headerText);

	// Content div
	var contentDiv = document.createElement('div');
	var contentHeight = h - 62;
	contentDiv.style.height = contentHeight + 'px';
	editItemForm.appendChild(contentDiv);
	
	var when = document.createElement('div');
	when.innerHTML = getWhenText(item.getStartTime(), item.getEndTime());
	when.style.marginTop = '20px';
	when.style.marginBottom = '10px';
	contentDiv.appendChild(when);

	var whatDiv = document.createElement('div');
	whatDiv.id = 'whatDiv';
	whatDiv.style.lineHeight = '20px';
	whatDiv.style.border = 'solid 1px transparent';
	contentDiv.appendChild(whatDiv);

	var whatInput = document.createElement('input');
	whatInput.id = 'whatField2';
	whatInput.className = 'popup-input2';
	whatInput.style.visibility = 'hidden';
	$addHandlers(whatInput, { 'blur': onWhatInputBlur }, this);
	$addHandlers(whatInput, { 'keyDown': onWhatInputKeyDown }, this);
	whatDiv.appendChild(whatInput);

	var what = document.createElement('div');
	what.className = 'popup-edit';
	what.style.height = '20px';
	what.id = 'what';
	what.innerHTML = item.getSubject();
	$addHandlers(what, { 'click': onWhatClick }, this);
	whatDiv.appendChild(what);

	// Create the custom form footer
	var editItemFormFooter = document.createElement('div');
	editItemFormFooter.className = 'buttons-row';
	editItemForm.appendChild(editItemFormFooter);
	
	// Save button
	var btnSave = document.createElement('a');
	btnSave.className = 'popup-button';
	btnSave.style.marginLeft = '5px';
	btnSave.innerHTML = 'Save';
	$addHandlers(btnSave, { 'click': editFormItem }, this);
	editItemFormFooter.appendChild(btnSave);

	// Discard button
	var btnDiscard = document.createElement('a');
	btnDiscard.className = 'popup-button';
	btnDiscard.style.marginLeft = '5px';
	btnDiscard.innerHTML = 'Discard';
	$addHandlers(btnDiscard, { 'click': closeEditItemForm }, this);
	editItemFormFooter.appendChild(btnDiscard);
	
	// Delete button
	var btnDelete = document.createElement('a');
	btnDelete.className = 'popup-link';
	btnDelete.style.marginLeft = '5px';
	btnDelete.innerHTML = 'Delete';
	$addHandlers(btnDelete, { 'click': deleteFormItem }, this);
	editItemFormFooter.appendChild(btnDelete);

	document.body.appendChild(editItemForm);
}

function onWhatInputBlur(e)
{
	if (hiding)
		return;
	hideWhatInput();
}

function onWhatInputKeyDown(e)
{
}

var hiding = false;
function hideWhatInput(cancel)
{
	var what = document.getElementById('what');
	var whatInput = document.getElementById('whatField2');
	if (!what || !whatInput)
		return;

	if (whatInput.style.visibility == 'hidden')
		return;

	hiding = true;
	whatInput.style.visibility = 'hidden';
	whatInput.blur();
	hiding = false;

	if (!cancel)
		what.innerHTML = whatInput.value;
}

function showWhatInput()
{
	var whatInput = document.getElementById('whatField2');
	if (!whatInput)
		return;
	if (whatInput.style.visibility == '')
		return;

	var what = document.getElementById('what');
	var whatDiv = document.getElementById('whatDiv');
	if (!what || !whatDiv)
		return;
		
	whatInput.style.visibility = '';
	whatInput.style.width = (whatDiv.offsetWidth - 7) + 'px';
	whatInput.style.height = (whatDiv.offsetHeight - 4) + 'px';
	whatInput.value = what.innerHTML;
	whatInput.focus();
	whatInput.select();
}

function onWhatClick(e)
{
	var what = document.getElementById('what');
	if (!what)
		return;

	showWhatInput();
}

function closeEditItemForm()
{
	try
	{
		if (editItemForm)
		{
			document.body.removeChild(editItemForm);
			editItemForm = null;
			editedItem = null;
		}
	}
	catch (err) { }
}

function editFormItem()
{
	if (!editedItem)
		return;

	var cal = $find('_calendar');
	if (!cal)
		return;

	var whatInput = document.getElementById('what');
	if (!whatInput)
		return;

	cal.editItem(editedItem,
		{
			subject: whatInput.innerHTML
		});

	closeEditItemForm();
}

function deleteFormItem()
{
	if (!editedItem)
		return;

	var cal = $find('_calendar');
	if (!cal)
		return;

	cal.deleteItem(editedItem);

	closeEditItemForm();
}

function showCalendarForm()
{
	if (addCalendarForm)
		closeCalendarForm();

	// Create the visible form frame, which will host the other html elements
	addCalendarForm = document.createElement('div');
	var h = 24;
	var w = 200;
	addCalendarForm.style.width = w + 'px';
	addCalendarForm.style.height = h + 'px';
	addCalendarForm.style.zIndex = 8000;

	// Place the form relatively to the target cell. Additionally apply the
	// appropriate style so that the pointer is positioned correctly
	var sourceButton = document.getElementById('addButton');
	var parentBounds = Sys.UI.DomElement.getBounds(sourceButton);
	var location = { x: parentBounds.x, y: parentBounds.y + parentBounds.height + bodyMargin };
	addCalendarForm.className = 'popup-uni';
	if (location.x + w > document.documentElement.clientWidth - 30)
	{
		location.x = parentBounds.x + parentBounds.width - w - 20;
		if (location.x < 0)
			location.x = 0;
	}
	if (location.y + h > document.documentElement.clientHeight - 30)
	{
		location.y = parentBounds.y - h - bodyMargin - 20;
		if (location.y < 0)
			location.y = 0;
	}
	Sys.UI.DomElement.setLocation(addCalendarForm, Math.round(location.x), Math.round(location.y));
	addCalendarForm.style.padding = '8px';
	addCalendarForm.style.fontSize = '9pt';

	var content = document.createElement('table');
	content.width = '100%';
	content.cellSpacing = '1px';
	content.cellPadding = '0';
	addCalendarForm.appendChild(content);
	
	var col1 = document.createElement('col');
	content.appendChild(col1);

	var col2 = document.createElement('col');
	content.appendChild(col2);

	var row = document.createElement('tr');
	content.appendChild(row);

	var td1 = document.createElement('td');
	row.appendChild(td1);
	var td2 = document.createElement('td');
	row.appendChild(td2);

	var calendarInput = document.createElement('input');
	calendarInput.id = 'calendarField';
	calendarInput.className = 'popup-input';
	td1.appendChild(calendarInput);

	// Add button
	var btnAdd = document.createElement('a');
	btnAdd.className = 'popup-button';
	btnAdd.style.padding = '2px';
	btnAdd.innerHTML = 'Add';
	$addHandlers(btnAdd, { 'click': createFormCalendar }, this);
	td2.appendChild(btnAdd);

	document.body.appendChild(addCalendarForm);

	calendarInput.focus();
}

function closeCalendarForm()
{
	try
	{
		if (addCalendarForm)
		{
			document.body.removeChild(addCalendarForm);
			addCalendarForm = null;
		}
	}
	catch (err) { }
}

function createFormCalendar()
{
	var calendarInput = document.getElementById('calendarField');
	if (!calendarInput)
		return;

	$get('haddres').value = calendarInput.value;
	__doPostBack('__Page');
}


var addItemForm;
var editItemForm;
var addCalendarForm;
var editedItem;
var start;
var end;
var upCell;
